;
; Startup code for cc65 (C64 version)
;

        .export         _exit
        .export         __STARTUP__ : absolute = 1      ; Mark as startup
        ;.exportzp	_i, _j, _Itm1, _CRoom, _CurPos, _CurVerb, _CurItem, _InitIn
        .exportzp	_i, _j, _Itm1, _CRoom, _CurPos, _CurItem, _InitV, _s, _Vrb, _c
        .exportzp	_CurStore, _CRm, _CurRoomInv, _e, _inx, _ItemPtr
        .exportzp	_ita

        .import         initlib, donelib
        .import         zerobss
        .import         _main, _hbzero, pushax
        .import         RESTOR, BSOUT, CLRCH
        .import         __MAIN_START__, __MAIN_SIZE__   ; Linker generated
        .import         __STACKSIZE__                   ; from configure file
        .importzp       ST
	.import		__HIDEBSS_LOAD__, __HIDEBSS_SIZE__

        .include        "zeropage.inc"
        .include        "c64.inc"


; ------------------------------------------------------------------------
; Startup code

.segment        "STARTUP"
; Switch off the BASIC ROM.

        lda     $01
        sta     mmusave         ; Save the memory configuration
        and     #$F8
        ora     #$06            ; Enable Kernal+I/O, disable BASIC
        sta     $01

        ;tsx
        ;stx     spsave          ; Save the system stack ptr

; Save space by putting some of the start-up code in the ONCE segment,
; which can be re-used by the BSS segment, the heap and the C stack.

        jsr     init

; Clear the BSS data.

        jsr     zerobss

; Push the command-line arguments; and, call main().

        jsr     _main

; Back from main() [this is also the exit() entry]. Run the module destructors.

_exit:  ;pha                     ; Save the return code on stack
        jsr     donelib

; Copy back the zero-page stuff.

;        ldx     #zpspace-1
;L2:     lda     zpsave,x
;        sta     sp,x
;        dex
;        bpl     L2

; Place the program return code into BASIC's status variable.

;        pla
;        sta     ST

; Restore the system stuff.

;        ldx     spsave
;        txs                     ; Restore stack pointer
;        ldx     mmusave
;        stx     $01             ; Restore memory configuration

; Back to BASIC.

;        rts
	jmp	($FFFC)


; ------------------------------------------------------------------------

.segment        "ONCE"

init:

; Save the zero-page locations that we need.

;        ldx     #zpspace-1
;L1:     lda     sp,x
;        sta     zpsave,x
;        dex
;        bpl     L1

; Set up the stack.

        lda     #<(__MAIN_START__ + __MAIN_SIZE__)
        ldx     #>(__MAIN_START__ + __MAIN_SIZE__)
        sta     sp
        stx     sp+1            ; Set argument stack ptr

; Switch to the second charset.

        lda     #14
        jsr     BSOUT

; Call the module constructors.

        jmp     initlib


; ------------------------------------------------------------------------
; Data

.segment        "INIT"
	
mmusave:.res    1
;spsave: .res    1
;zpsave: .res    zpspace
.segment "HIDEBSS"

.segment "TAPESTART"
.word	$334

.segment "BAS2START"
.word	$2A7

.segment "BASINSTART"
.word	$0200

.segment "ZP2START"
.word	$003A

.zeropage
_i:		.res	1
_j:		.res	1
_Itm1:		.res	1
_CRoom:		.res	1
_CurPos:	.res	1
;_CurVerb:	.res	1
_CurItem:	.res	1
_InitV:		.res	2
_s:		.res	2
_Vrb:		.res	1
_c:		.res	1
_CurStore:	.res	2
_CRm:		.res	2
_CurRoomInv:	.res	2
_e:		.res	1
_inx:		.res	2
_ItemPtr:	.res	2
_ita:		.res	2

